import type { DoublyLinkedList } from './types';
import * as iterable from '../core/traits/iterable';
export declare class LinkedList<T = any> implements DoublyLinkedList<T> {
    #private;
    /**
     * Check if the argument is an linked list
     * @returns true if the argument is a linked list, otherwise false
     */
    static isLinkedList(linkedList: any): linkedList is LinkedList<any>;
    constructor(iterator?: Iterable<T> | null);
    get size(): number;
    get head(): any;
    get tail(): any;
    [Symbol.iterator](): Iterable<T> & Iterator<T, any, undefined>;
    values(): Iterable<T> & Iterator<T, any, undefined>;
    keys(): Iterable<number> & Iterator<number, any, undefined>;
    entries(): Iterable<iterable.Entry<T>> & Iterator<iterable.Entry<T>, any, undefined>;
    push(...items: T[]): number;
    unshift(...items: T[]): number;
    pop(): T | undefined;
    shift(): T | undefined;
    get(index: number): T | undefined;
    set(index: number, value: T): boolean;
    delete(index: number): T | undefined;
    insert(index: number, value: T): boolean;
    clear(): void;
    slice(start?: number, end?: number): LinkedList<T>;
    copy(): LinkedList<T>;
}
